///添加监听
chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
  if (request && request.sign === 'signDxm') {
    if (request.action === 'checkProduct') {
      backEvent.checkProduct(request.data, sendResponse);
      return true
    }else if(request.action==='postData'){
      backEvent.postData(request.data, sendResponse);
      return true
    }else if(request.action==='addProduct'){
      backEvent.addProduct(request.data, sendResponse);
      return true
    }else if(request.action === 'getHtml'){
        backEvent.getHtml(request.data, sendResponse);
        return true
    }else if(request.action === 'postHtml'){
        backEvent.postHtml(request.data, sendResponse);
        return true
    }else if(request.action === 'getData'){
        backEvent.getData(request.data, sendResponse);
        return true
    }
  }
});
var baseurl = 'https://crawl.51microshop.com';
//var baseurl = 'https://1.51microshop.com';
var backEvent = {  
 
  //获取采集页面
  getHtml: function (data, call) {
    var url = data.url,
      try_times = data.try_times,
      callback = data.callback,
      sync = data.sync == 'false' ? false : true;

    $.ajax({
      url: url,
      type: "GET",
      async: sync,
      timeout: 60000,
      data: {},
      success: function (data) {
        typeof (data) == "object" && (data = JSON.stringify(data));
        call({ html: data });
      },
      complete: function (XMLHttpRequest, status) {
        if (status == 'timeout') {
          try_times >= 3 ? call({ html: "" }) :
            setTimeout(function () {
              var dataNew = {
                url: url,
                try_times: try_times + 1,
                callback: callback
              };
              backEvent.getHtml(dataNew, call);
            }, 5000);
        } else if (status == 'parsererror') {
          var data = XMLHttpRequest.responseText;
          call({ html: data });
        } else if (status == 'error') {
          call({ html: "" });
        }
      }
    });
  },
  //去后台采集
  postHtml: function (data, call) {
    var url = data.url,
      params = data.params,
      try_times = data.try_times,
      async = data.sync == 'false' ? false : true;

    //console.log(params);
    $.ajax({
      url: url,
      type: "POST",
      timeout: 60000,
      async: async,
      data: params,
      dataType: "json",
      success: function (data) {
        call(data);
      }, error: function () {//增加访问出错信息返回
        call({ "code": 0, "msg": "" });
      }
      ,
      complete: function (XMLHttpRequest, status) {
        if (status == 'error') {
          call({ "code": -1, "msg": "请求出错" });
        } else if (status == 'parsererror') {
          call({ "code": -1, "msg": "您的店小秘账号sk请先登录店小秘" });
        } else if (status == 'timeout') {
          call({ "code": 0, "msg": "" });
        }
      }
    });
  },
  //获取数据
  getData: function (data, call) {
    var url = data.url,
      try_times = data.try_times,
      callback = data.callback;

    //console.log(params);
    $.ajax({
      url: url,
      type: "GET",
      timeout: 60000,
      data: {},
      async: false,
      success: function (data) {
        typeof (data) == "object" && (data = JSON.stringify(data));
        call({ html: data });
      },
      complete: function (XMLHttpRequest, status) {
        if (status == 'timeout') {
          try_times >= 3 ? call({ html: "" }) :
            setTimeout(function () {
              var dataNew = {
                url: url,
                try_times: try_times + 1,
                callback: callback
              };
              backEvent.getData(dataNew, call)
            }, 5000);
        } else if (status == 'parsererror') {
          var data = XMLHttpRequest.responseText;
          call({ html: data });
        } else if (status == 'error') {
          call({ html: "" });
        }
      }
    });
  },
  //发送数据
  postData:function (data, call) {
    var statusData = {
      success: false,
      message:'未知原因'
    };
    $.ajax({
      url: data.url,
      type: "POST",
      async: false,
      data: data.params,
      dataType: "json",
      timeout: 10000,
      success: function (data) {
        statusData = data;
      }
    });
    return call(statusData)
  },
  //是否重复采集
  checkProduct: function (data, call) {
    var statusData = {
      success: false,
      message:'未知原因'
    };
    $.ajax({
      url: baseurl + '/Ajax/AjaxHandler.ashx?ajax=CheckProduct',
      type: "POST",
      async: false,
      data: data.params,
      dataType: "json",
      timeout: 10000,
      success: function (data) {
        statusData = data;
      }
    });
    return call(statusData)
  },
  //添加产品
  addProduct:function(data,call){
    var statusData = {
      success: false,
      message:'未知原因'
    };
    $.ajax({
      url: baseurl + '/Ajax/AjaxHandler.ashx?ajax=AddProduct',
      type: "POST",
      async: false,
      data: data.params,
      dataType: "json",
      timeout: 10000,
      success: function (data) {
        statusData = data;
      }
    });
    return call(statusData)
  }
};